Paw-park/Models/Park.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated from a template.
//
//     Manual changes to this file may cause unexpected behavior in your application.
//     Manual changes to this file will be overwritten if the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Paw_park.Models
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;

    public partial class Park
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public Park()
        {
            this.Bookings = new HashSet<Booking>();
            this.Comments = new HashSet<Comment>();
            this.Equipments = new HashSet<Equipment>();
        }

        public int Id { get; set; }
        [Display(Name = "Pargi nimi")]
        public string Name { get; set; }
        [Display(Name = "Asukoht")]
        public string Location { get; set; }
        [Display(Name = "Tp")]
        public Nullable<int> Type { get; set; }
        [Display(Name = "Mahutavus")]
        public Nullable<int> Capacity { get; set; }
        [Display(Name = "Foto")]
        public Nullable<int> PictureId { get; set; }


        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Booking> Bookings { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Comment> Comments { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Equipment> Equipments { get; set; }
        public virtual DataFile DataFile { get; set; }
    }
}

Paw-park/Controllers/ParksController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using Paw_park.Models;
using System.IO;

namespace Paw_park.Controllers
{
    public class ParksController : Controller
    {
        private PatrullEntities db = new PatrullEntities();

        // GET: Parks
        public ActionResult Index()
        {
            {
                var departments = db.Parks.Include(d => d.DataFile);
                return View(departments.ToList());


                //string filename = @"C:\Users\siira\source\repos\paw-park3\Paw-park\Koertepargid.txt";
                //string[] pargidtxt = System.IO.File.ReadAllLines(filename);
                //List<Park> pargid = new List<Park>();
                //for (int i = 1; i < pargidtxt.Length; i++)
                //{
                //    string[] reaosad = pargidtxt[i].Split(',');
                //    db.Parks.Add(
                //    new Park
                //    {
                //        Name = reaosad[0],
                //        Location = reaosad[1],
                //    });
                //}


                //this.Bookings = new HashSet<Booking>();
                //this.Comments = new HashSet<Comment>();
                //this.Equipments = new HashSet<Equipment>();

            }
        }

        // GET: Parks/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Park park = db.Parks.Find(id);
            if (park == null)
            {
                return HttpNotFound();
            }
            return View(park);
        }

        // GET: Parks/Create
        public ActionResult Create()
        {
            //ViewBag.Name = new SelectList(Park.DogParks, "Key", "Value");

            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType");
                return View();
        }

        // POST: Parks/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Id,Name,Location,Type,Capacity,PictureId")] Park park)
        {
            if (ModelState.IsValid)
            {
                db.Parks.Add(park);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            //ViewBag.Name = new SelectList(Park.DogParks, "Key", "Value");

            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", park.PictureId);
            return View(park);
        }

        // GET: Parks/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Park park = db.Parks.Find(id);
            if (park == null)
            {
                return HttpNotFound();
            }
            return View(park);
        }

        // POST: Parks/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Id,Name,Location,Type,Capacity,PictureId")] Park park
            , HttpPostedFileBase file)
        {
            string[] vead = db.GetValidationErrors()
                .Select(x => string.Join(",", x.ValidationErrors.Select(y => y.ErrorMessage))).ToArray();


            if (ModelState.IsValid)
            {
                db.Entry(park).State = EntityState.Modified;
                db.SaveChanges();

                if (file != null && file.ContentLength > 0)
                    using (BinaryReader br = new BinaryReader(file.InputStream))
                    {
                        DataFile df = new DataFile
                        {
                            FileName = file.FileName.Split('\\').Last(),
                            ContentType = file.ContentType,
                            Content = br.ReadBytes(file.ContentLength),
                            Created = DateTime.Now,
                        };
                        db.DataFiles.Add(df);
                        db.SaveChanges();
                        // vana pildi kustutamiseks jätame meelde pildi numbri
                        int? vanaPiltId = park.PictureId;
                        park.PictureId = df.Id;
                        db.SaveChanges();
                        if (vanaPiltId.HasValue)
                        {
                            db.DataFiles.Remove(db.DataFiles.Find(vanaPiltId.Value));
                            db.SaveChanges();
                        }
                    }

                return RedirectToAction("Index");
            }
            ViewBag.PictureId = new SelectList(db.DataFiles, "Id", "ContentType", park.PictureId);
            return View(park);
        }

        // GET: Parks/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Park park = db.Parks.Find(id);
            if (park == null)
            {
                return HttpNotFound();
            }
            return View(park);
        }

        // POST: Parks/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Park park = db.Parks.Find(id);
            db.Parks.Remove(park);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Paw-park/Views/Parks/Create.cshtml
@model Paw_park.Models.Park

@{
    ViewBag.Title = "Create";
}

<h2>Lisa park</h2>

@using (Html.BeginForm("Edit", "Parks", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

<div class="form-horizontal">
    <h4>Park</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    <div class="form-group">
        @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Location, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Location, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Location, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Type, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Type, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Type, "", new { @class = "text-danger" })

        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Capacity, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Capacity, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Capacity, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.PictureId, "PictureId", htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.DropDownList("PictureId", null, htmlAttributes: new { @class = "form-control" })
            @Html.ValidationMessageFor(model => model.PictureId, "", new { @class = "text-danger" })
        </div>
    </div>
       
    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Salvesta" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Tagasi", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Paw-park/Views/Parks/Delete.cshtml
@model Paw_park.Models.Park

@{
    ViewBag.Title = "Delete";
}

<h2>Kustuta</h2>

<h3>Oled kindel, et tahad pargi kustutada?</h3>
<div>
    <h4>Park</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Location)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Location)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Type)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Type)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Capacity)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Capacity)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PictureId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PictureId)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Kustuta" class="btn btn-default" /> |
            @Html.ActionLink("Tagasi", "Index")
        </div>
    }
</div>

Paw-park/Views/Parks/Details.cshtml
@model Paw_park.Models.Park

@{
    ViewBag.Title = "Details";
}

<h2>Vaata</h2>

<div>
    <h4>Park</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Location)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Location)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Type)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Type)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Capacity)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Capacity)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PictureId)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PictureId)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Muuda", "Edit", new { id = Model.Id }) |
    @Html.ActionLink("Tagasi", "Index")
</p>

Paw-park/Views/Parks/Edit.cshtml
@model Paw_park.Models.Park

@{
    ViewBag.Title = "Edit";
}

<h2>Muuda</h2>

@using (Html.BeginForm("Edit", "Parks", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
<div class="form-horizontal">
    <h4>Park</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
    @Html.HiddenFor(model => model.Id)

    <div class="form-group">
        @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Location, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Location, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Location, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Type, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Type, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Type, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.Capacity, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Capacity, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Capacity, "", new { @class = "text-danger" })
        </div>
    </div>

    <div class="form-group">
        @Html.LabelFor(model => model.PictureId, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.PictureId, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.PictureId, "", new { @class = "text-danger" })
        </div>
    </div>

    @*<div class="form-group">
            @Html.LabelFor(model => model.PictureId, "PictureId", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("PictureId", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.PictureId, "", new { @class = "text-danger" })
            </div>
        </div>*@
    @Html.HiddenFor(x => x.PictureId)

    <input type="file" name="picture" id="file" />



    <div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Salvesta" class="btn btn-default" />
        </div>
    </div>
</div>
}

<div>
    @Html.ActionLink("Tagasi", "Index")
</div>

Paw-park/Views/Parks/Index.cshtml
@model IEnumerable<Paw_park.Models.Park>

@{
    ViewBag.Title = "Index";
}

<h2>Pargid</h2>

<p>
    @Html.ActionLink("Lisa park", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Location)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Type)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Capacity)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.PictureId)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
<tr>
    <td>
        @Html.DisplayFor(modelItem => item.Name)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Location)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Type)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.Capacity)
    </td>
    <td>
        @Html.DisplayFor(modelItem => item.PictureId)
    </td>

    <td>
        @*@Html.DisplayFor(modelItem => item.DataFile.ContentType)*@
        <img src="@Url.Action("Content", "DataFiles", new { id = item.PictureId })" height="100" />
    </td>


    <td>
        @Html.ActionLink("Muuda", "Edit", new { id = item.Id }) |
        @Html.ActionLink("Vaata", "Details", new { id = item.Id }) |
        @Html.ActionLink("Kustuta", "Delete", new { id = item.Id })
    </td>
</tr>
}

</table>